Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/optimize.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/optimize.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/optimize.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2014 by TOPPERS Project
+#   Copyright (C) 2008-2018 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -178,4 +178,5 @@
 
   def set_domain
+    domain_cells = {}
     @cell_list.each{ |c|
       if c.is_generate? then
@@ -191,4 +192,9 @@
           @domain_roots[ dn ] = [ dr ]
         end
+        if domain_cells[ dr ]  then
+          domain_cells[ dr ] << c
+        else
+          domain_cells[ dr ] = [ c ]
+        end
       end
     }
@@ -196,10 +202,21 @@
     @domain_roots.each{ |dn, drs|
       drs.uniq!
-      if ! $debug then
-        dbgPrint "domains celltype:#{@name} domain=#{dn} "
+      if $verbose && dn then
+        print "[domain] celltype=#{@name} domainType=#{dn} domainRootRegions={"
+        delim = ""
         drs.each{ |r|
-          dbgPrint " region=#{r.get_name}"
+          print delim, r.get_name
+          delim = ", "
         }
-        dbgPrint "\n"
+        print "}\n"
+        drs.each{ |r|
+          print "[domain] celltype=#{@name} domainRootRegion=#{r.get_name} domainType=#{dn} domainKind=#{r.get_domain_root.get_domain_type.get_kind} domainCells={"
+          delim = ""
+          domain_cells[r].each{ |c|
+            print delim, c.get_name
+            delim = ", "
+          }
+          print "}\n"
+        }
       end
     }
@@ -212,9 +229,12 @@
       # domain_type は一つのノードに一つしかないので、一つの要素を無条件で取り出す
       if regions.length > 1 then
-        cdl_info( "celltype:#{@name} has cells in multi domain.\n" )
-        if @idx_is_id == false then
-          cdl_info( "celltype:#{@name} forcely set idx_is_id\n" )
-        end
-        @idx_is_id_act = true
+        if $verbose then
+          cdl_info( "I9999 celltype '$1' has cells in multi-domain.\n", @name )
+        end
+        # if @idx_is_id == false then
+        #   cdl_info( "I9999 celltype '$1' forcely set idx_is_id\n", @name )
+        # end
+        @b_need_ptab = true
+        # @idx_is_id_act = true
       end
     }
@@ -228,4 +248,12 @@
     end
 
+    optimize_call
+    if $unopt_entry == false then
+      optimize_entry
+    end
+  end
+
+  #=== Celltype#呼び口最適化
+  def optimize_call
     @port.each{ |port|
       next if port.get_port_type != :CALL
@@ -238,4 +266,14 @@
         if $verbose then
           print "optimized by omit: port: #{port.get_name} : o\n"
+        end
+        next
+      elsif port.is_dynamic? then
+        if $verbose then
+          print "unoptimized by dynamic: port: #{port.get_name}\n"
+        end
+        next
+      elsif port.is_ref_desc? then
+        if $verbose then
+          print "unoptimized by ref_desc: port: #{port.get_name}\n"
         end
         next
@@ -351,5 +389,9 @@
       dbgPrint "#{port.get_name} : # of cells : #{port_cells.length}  # of ports : #{port_ports.length}\n"
     }
-
+  end
+
+  #=== Celltype#受け口最適化
+  # optimize_entry は、呼び口最適化の結果を使用している
+  def optimize_entry
     # 受け口最適化の設定
     @port.each{ |port|
Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/plugin.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/plugin.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/plugin.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2014 by TOPPERS Project
+#   Copyright (C) 2008-2017 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -38,5 +38,5 @@
 #++
 
-#== class モジュール
+#== Plugin クラス
 # ThroughPlugin, SignaturePlugin, CelltypePlugin に include する
 class Plugin < Node
@@ -75,5 +75,8 @@
   end
 
-### 意味解析段階で呼び出されるメソッド ###
+### 構文解釈 または 意味解析段階で呼び出されるメソッド ###
+# generate 指定子の場合、構文解釈次第(end_of_parseで)呼び出される
+# generate 文の場合、出現次第呼び出される
+  ### 意味解析段階で呼び出されるメソッド ### <<< コメント誤り (V1.4.2)
   #===  CDL ファイルの生成
   #      typedef, signature, celltype, cell のコードを生成
@@ -157,5 +160,5 @@
       #  識別子取得
       if arg =~ /\A[a-zA-Z_]\w*/ then
-        ident = $~
+        ident = $~.to_s    # 
         arg = $'
       else
@@ -285,6 +288,6 @@
 end
 
-#== 出力文字列を EUC から出力ファイルに convert する
-# tecsgen のソースコードは EUC で記述されている
+#== 出力文字列を utf-8 から出力ファイルに convert する
+# tecsgen のソースコードは utf-8 で記述されている
 # これを、出力ファイルの文字コードに変換して出力する
 #
Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/pluginModule.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/pluginModule.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/pluginModule.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2014 by TOPPERS Project
+#   Copyright (C) 2008-2017 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -45,5 +45,9 @@
 
   #=== プラグインをロードする
-  #return:: true : 成功、 false : 失敗
+  # return:: PluginClass
+  # V1.4.1 まで return:: true : 成功、 false : 失敗
+  #
+  # #{plugin_name}.rb をロードし、plugin_name クラスのオブジェクトを生成する．
+  # plugin_name が MultiPlugin の場合、get_plugin により、superClass のプラグインオブジェクトをロードする．
   #
   # すでにロードされているものは、重複してロードしない
@@ -59,19 +63,25 @@
         end
         # "#{plugin_name}.rb" をロード（システム用ではないので、fatal エラーにしない）
-        if require_tecsgen_lib( "#{plugin_name}.rb", false ) == false
+        if require_tecsgen_lib( "#{plugin_name}.rb", false ) == false then
           cdl_error( "P2001 $1.rb : fail to load plugin" , plugin_name )
-          return false
+          return nil
         end
       end
 
-      plSuper = nil
-      # eval( "plSuper = #{plugin_name}.superclass" )
-      eval( "plSuper = #{plugin_name}" )
-      while plSuper != superClass && plSuper != nil
-        plSuper = plSuper.superclass
-      end
-      if plSuper == nil then
+      plClass = Object.const_get plugin_name
+      if ( plClass <= superClass ) then       # plClass inherits superClass
+        return plClass
+      elsif (plClass <= MultiPlugin) then     # plClass inherits MultiPlugin
+        dbgPrint "pluginClass=#{plClass}\n"
+        plugin_object = plClass.get_plugin superClass
+        dbgPrint "pluginClass=#{plugin_object}\n"
+        if plugin_object == nil then
+          cdl_error( "P9999 '$1': MultiPlugin not support '$2'", plugin_name, superClass.name )
+        end
+        @@loaded_plugin_list[ plugin_name.to_sym ] = :MultiPlugin
+        return plugin_object
+      else
         cdl_error( "P2002 $1: not kind of $2" ,  plugin_name, superClass.name )
-        return false
+        return nil
       end
     rescue Exception => evar
@@ -81,7 +91,8 @@
       end
       cdl_error( "P2003 $1: load failed" , plugin_name )
-      return false
+      return nil
     end
-    return true
+    # ここへは来ない
+    return nil
   end
 
@@ -92,7 +103,12 @@
     end
     plugin_name = plugin_object.class.name.to_sym
-    if @@loaded_plugin_list[ plugin_name ] == nil
-      raise "#{plugin_name} might have different name "
-      # プラグインのファイル名と、プラグインのクラス名が相違する場合
+    if @@loaded_plugin_list[ plugin_name ] == :MultiPlugin then
+      p "#{plugin_name}: MultiPlugin"
+      return
+    elsif @@loaded_plugin_list[ plugin_name ] == nil then
+      #raise "#{plugin_name} might have different name "
+      ## プラグインのファイル名と、プラグインのクラス名が相違する場合
+      #MultiPlugin の get_plugin で返されたケースでは nil になっている
+      @@loaded_plugin_list[ plugin_name ] = 0
     end
     count = @@loaded_plugin_list[ plugin_name ]
@@ -131,4 +147,7 @@
     dbgPrint "PluginModule #{@@loaded_plugin_list}\n"
     @@loaded_plugin_list.each{ |plugin_name,count|
+      if count == :MultiPlugin then
+        next
+      end
       dbgPrint "PluginModule: #{plugin_name}\n"
       eval_str = "#{plugin_name}.gen_post_code( file )"
Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/syntaxobj.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/syntaxobj.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/syntaxobj.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2016 by TOPPERS Project
+#   Copyright (C) 2008-2017 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -86,6 +86,11 @@
 
   #=== 情報を表示する
-  def cdl_info( message )
-    Console.puts "info: #{message}"
+  def cdl_info( message, *arg )
+    Generator.info2( @locale, message, *arg )
+  end
+
+  #=== 情報を表示する
+  def cdl_info2( locale, message, *arg )
+    Generator.info2( locale, message, *arg )
   end
 
@@ -680,4 +685,11 @@
   end
 
+  #=== Decl# print_flowinfo
+  def print_flowinfo file
+    if @kind == :VAR then
+      file.write "#{@identifier} "
+    end
+  end
+
   def show_tree( indent )
     indent.times { print "  " }
